/* Generate coff file
   Copyright 2002, 2003, 2004, 2005
   Craig Franklin
*/

#pragma once

#define SECTION_FLAGS state.obj.flags
#define IS_RAM_ORG    (SECTION_FLAGS & STYP_RAM_AREA)

EXTERN_C void coff_init(void);
extern void coff_cleanup_before_eof(void);
EXTERN_C void coff_close_file(void);
EXTERN_C void coff_new_section(const char *Name, unsigned Byte_addr, unsigned Flags);
EXTERN_C void coff_close_section(void);

EXTERN_C gp_symbol_t* coff_add_sym(const char *Name, gpasmVal Value, enum gpasmValTypes Type,
                                 int Section_number);

extern void coff_add_reloc(unsigned Symbol_number, int Offset, uint16_t Type);
EXTERN_C void coff_add_linenum(unsigned Emitted);
EXTERN_C gp_symbol_t* coff_add_file_sym(const char *File_name, bool Is_include);
EXTERN_C void coff_add_eof_sym(void);
EXTERN_C void coff_add_list_sym(void);
EXTERN_C void coff_add_nolist_sym(void);
EXTERN_C void coff_add_direct_sym(uint8_t Command, const char *String);
EXTERN_C void coff_add_ident_sym(const char *String);
EXTERN_C char *coff_local_name(const char *Name);

